#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <queue>
#include <iterator>
#include <deque>

#define ll long long
#define endl '\n'
using namespace std;
ll mod = 1e9 + 7;

ll bp(ll a, ll b) {
    if (b == 0)
        return 1;
    ll now = bp(a, b / 2);
    if (b % 2) {
        ll q = now * now % mod;
        return a * q % mod;
    }
    else {
        return now * now % mod;
    }
}

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}
bool check(pair<ll,ll> st1, pair<ll, ll> fn1, pair<ll, ll> st2, pair<ll, ll> fn2) {
    fn1.first -= st1.first;
    st2.first -= st1.first;
    fn2.first -= st1.first;
    st1.first = 0;
    fn1.second -= st1.second;
    st2.second -= st1.second;
    fn2.second -= st1.second;
    st1.second = 0;
    ll a, b, c = 0;
    a = fn1.second;
    b = -fn1.first;
    ll c1 = a * st2.first + b * st2.second;
    if (c1 == 0)
        return true;
    c1 /= abs(c1);
    ll c2 = a * fn2.first + b * fn2.second;
    if (c2 == 0)
        return true;
    c2 /= abs(c2);
    if (c1 != c2) {
        ll a1, b1, c1;
        fn2.first -= st2.first;
        st1.first -= st2.first;
        fn1.first -= st2.first;
        st2.first = 0;
        fn2.second -= st2.second;
        st1.second -= st2.second;
        fn1.second -= st2.second;
        st2.second = 0;
        c1 = 0;
        a1 = fn2.second;
        b1 = -fn2.first;
        c1 = a1 * st1.first + b1 * st1.second;
        if (c1 == 0)
            return true;
        c1 /= abs(c1);
        c2 = a1 * fn1.first + b1 * fn1.second;
        if (c2 == 0)
            return true;
        c2 /= abs(c2);

        if (c1 != c2)
            return true;
    }
    return false;
}
void solve() {
    ll n; cin >> n;

    vector < pair<pair< ll, ll>, pair<ll,ll>>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second >> a[i].second.first >> a[i].second.second;
    }
    ll cnt = 0;
    vector <vector <ll>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (check(a[i].first, a[i].second, a[j].first, a[j].second)) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector <vector <ll>> comp(0);
    vector <bool> used(n, false);
    for (ll i = 0; i < n; ++i) {
        if (!used[i]) {
            queue <ll> q;
            q.push(i);
            comp.push_back({});
            used[i] = true;
            while (!q.empty()) {
                auto now = q.front();
                q.pop();
                comp[comp.size() - 1].push_back(now);
                for (auto j : g[now]) {
                    if (!used[j]) {
                        used[j] = true;
                        q.push(j);
                    }
                }
            }
        }
    }
    ll ans = 1;
    for (auto now : comp) {
        ll ct = 0;
        for (auto h : now) {
            ct += g[h].size();
        }
        ct /= 2;
        ans += max(0ll, ct - (ll)now.size() + 1);
    }
    cout << ans << endl;
}
void FAST1() {
    cin.tie(NULL);
    cout.tie(NULL);
}
void FAST2() {
    ios_base::sync_with_stdio(false);
}
int main()
{
    
    FAST1();
    FAST2();
    int tt = 1; cin >> tt;
    while (tt--) {
        solve();
    }
}
