#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define pii pair<int, int>
#define F first
#define s second
#define int long long

const int N = 2e5 + 100;

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());
typedef tree <pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update> oset;

struct node {
    int lst, mn, pmn;

    bool operator == (node a) {
        return (lst == a.lst && a.mn == mn && pmn == a.pmn);
    }
};

node merg (node a, node b) {
    if (a == node{-10000000, -102929, -1337}) return b;
    if (b == node{-10000000, -102929, -1337}) return a;
    node c;
    c.lst = b.lst;
    if (a.mn > b.mn) {
        c.mn = b.mn;
        c.pmn = b.pmn;
    }
    else {
        c.mn = a.mn;
        c.pmn = a.pmn;
    }
    return c;
}

struct segment_tree {
    node t[N*4];

    void upd (int v, int vl, int vr, int p, int x) {
        if (vl == vr) {
            t[v] = node{x, x, p};
            return;
        }
        int m = (vl+vr)>>1;
        if (p <= m) {
            upd((v<<1), vl, m, p, x);
        }
        else {
            upd((v<<1)|1, m+1, vr, p, x);
        }
        t[v] = merg(t[(v<<1)], t[(v<<1)|1]);
    }

    node get (int v, int vl, int vr, int l, int r) {
//        cout << "G: " << vl << ' ' << vr << ' ' << l << ' ' << r << '\n';
        if (vl > r || vr < l) {
            return node{-10000000, -102929, -1337};
        }
        if (vl >= l &&  vr <= r) {
//            cout << "G: " << vl << ' ' << vr << ' ' << l << ' ' << r << '\n';
            return t[v];
        }
        int m = (vl+vr)>>1;
        return merg(get((v<<1), vl, m, l, r), get((v<<1)|1, m+1, vr, l, r));
    }

    void out (int v, int vl, int vr) {
        cout << "! " << v << ' ' << vl << ' ' << vr << ' ' << t[v].mn << ' ' << t[v].pmn << ' ' << t[v].lst << '\n';
        if (vl < vr) {
            int m = (vl+vr)>>1;
            out((v<<1), vl, m);
            out((v<<1)|1, m+1, vr);
        }
    }
};

int ps[N];
int n, q;

segment_tree t;

void solve ()
{
    fill(t.t, t.t+4*N, node{-10000000, -102929, -1337});
    int n, q;
    cin >> n >> q;
    ps[0] = 0;
    string s;
    cin >> s;
    for (int i=0;i<n;++i) {
        ps[i+1] = ps[i];
        if (s[i] == '(') {
            ps[i+1]++;
        }
        else {
            ps[i+1]--;
        }
        t.upd(1, 0, n, i+1, ps[i+1]);
    }
//    t.out(1, 0, n);
//    for (int i=0;i<=n;++i) {
//        cout << ps[i] << ' ';
//    }
//    cout << '\n';

    for (int it=0;it<q;++it) {
        int l, r;
        cin >> l >> r;
        node c = t.get(1, 0, n, l, r);
//        cout << c.mn << ' ' << c.pmn << ' ' << c.lst << '\n';
        c.mn -= ps[l-1];
        c.pmn -= l-1;
        c.lst -= ps[l-1];
//        cout << c.mn << ' ' << c.pmn << ' ' << c.lst << '\n';
        cout << min(max(0ll, -c.mn) + abs(c.lst + max(0ll, -c.mn)), c.pmn + abs(c.lst)) << '\n';
    }
}

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q = 1;
//    cin >> q;
    for (;q;--q) {
        solve();
    }
    return 0;
}
