#include <iostream>
#include <bits/stdc++.h>
#include <vector>

using ll = long long;

#define rep(i, n) for (int i = 0; i < n; i++)
#define repi(i, a, b) for (int i = a; i < b; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()
#define vi vector<ll>
#define vvi vector<vi>

using namespace std;

struct Hash{
    ll p, q;
    vi pq, pref, suff;

    ll add(ll a, ll b) {
        ll res = a + b;
        if (res >= q) res += q;
        return res;
    }

    ll sub(ll a, ll b) {
        ll res = a - b;
        if (res < 0) res += q;
        return res;
    }

    ll mul(ll a, ll b) {
        return (a * b) % q;
    }

    Hash(ll n, ll p_, ll q_, string&s) {
        p = p_, q = q_;
        pq.assign(n + 1, 1);
        pref.assign(n + 1, 0);
        suff.assign(n + 1, 0);
        rep(i, n) {
            pref[i + 1] = add(mul(pref[i], p), s[i] - 'a' + 1);
            suff[n - i - 1] = add(mul(suff[n - i], p), s[n - i - 1] - 'a' + 1);
            pq[i + 1] = mul(pq[i], p);
        }
    }

    ll get_hash_pref(ll l, ll r) {
        return sub(pref[r + 1], mul(pref[l], pq[r - l + 1]));
    }

    ll get_hash_suff(ll l, ll r) {
        return sub(pref[l], mul(pref[r + 1], pq[r - l + 1]));
    }
};

void solve() {
    ll w0, h0, w, h, x, y; cin >> w0 >> h0 >> w >> h >> x >> y;
    ll ans = 0; ll hg = 1;
    if (h0 - y - h > 0)
        hg += (h0 - y - h + h - 1) / h;
    if (y)
        hg += (y + h - 1) / h;
    ll wt = 1;
    if (w0 - x - w > 0)
        wt += (w0 - x - w + w - 1) / w;
    if (x)
        wt += (x + w - 1) / w;
    cout << wt * hg - 1 << '\n';
}

int main()
{
    ios::sync_with_stdio(0);
    cout.tie(0);

    ll t = 1; cin >> t;
    rep(_, t) {
        solve();
    }
}
