#include <iostream>
#include <bits/stdc++.h>
#include <vector>

using ll = long long;

#define rep(i, n) for (int i = 0; i < n; i++)
#define repi(i, a, b) for (int i = a; i < b; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()
#define vi vector<ll>
#define vvi vector<vi>

using namespace std;

struct Hash{
    ll p, q;
    vi pq, pref, suff;

    ll add(ll a, ll b) {
        ll res = a + b;
        if (res >= q) res += q;
        return res;
    }

    ll sub(ll a, ll b) {
        ll res = a - b;
        if (res < 0) res += q;
        return res;
    }

    ll mul(ll a, ll b) {
        return (a * b) % q;
    }

    Hash(ll n, ll p_, ll q_, string&s) {
        p = p_, q = q_;
        pq.assign(n + 1, 1);
        pref.assign(n + 1, 0);
        suff.assign(n + 1, 0);
        rep(i, n) {
            pref[i + 1] = add(mul(pref[i], p), s[i] - 'a' + 1);
            suff[n - i - 1] = add(mul(suff[n - i], p), s[n - i - 1] - 'a' + 1);
            pq[i + 1] = mul(pq[i], p);
        }
    }

    ll get_hash_pref(ll l, ll r) {
        return sub(pref[r + 1], mul(pref[l], pq[r - l + 1]));
    }

    ll get_hash_suff(ll l, ll r) {
        return sub(pref[l], mul(pref[r + 1], pq[r - l + 1]));
    }
};

#define INF 2e9 + 11
#define int long long

vi dels(ll n) {
    vi res;
    for (int i = 1; i * i <= n; i++) {
        if ((n % i) == 0) {
            res.push_back(i);
            if (n / i != i) res.push_back(n / i);
        }
    }
    return res;
}

int stupid(ll x, ll y) {
    rep(i, x) {
        if ((y - i) % (x - i) == 0) {
            return i;
        }
    }
}

mt19937 rnd(time(0));

void solve() {
    //   (y - x)
    // ll y = rnd() % 10000, x = max(1ll, rnd() % y);
    ll x, y; cin >> x >> y;
    if (y % x == 0) {
        cout << 0 << '\n';
        return;
    }
    ll d = y - x;
    vi c = dels(d);
    ll ans = x - 1;
    each(i, c) {
        ll v = x - i;
        if (x - v > 0 && v > 0 && (((y - v) % (x - v)) == 0))
            ans = min(ans, v);
    }
    /*if (ans != stupid(x, y)) {
        cerr << x << " " << y << " " << ans << " " << stupid(x, y) << endl;
    }*/
    cout << ans << '\n';
}

signed main()
{
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    ll t = 1; cin >> t;
    rep(_, t) {
        solve();
    }
    cerr << "finish";
}
