#define _CRT_SECURE_NO_WARNINGS
#include <cstddef>
#include <cstdint>
#include <cstdio>
#include <cstdlib>
#include <cmath>

#include <algorithm>
#include <type_traits>
#include <limits>
#include <functional>
#include <iostream>

#include <vector>
#include <array>
#include <deque>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>

using int64 = long long;
using uint64 = unsigned long long;
using flt = float;
using dbl = double;

using namespace std;

void TaskC( void )
{
  int64 t, x, y;
  scanf("%lli", &t);

  std::vector<int64> Stack {};

  while (t--)
  {
    scanf("%lli %lli", &x, &y);

    if (y % x == 0)
      printf("0\n");
    else
    {
      int64 diff = y-x;
      int64 i = 1;

      for (; i*i <= diff; i++)
      {
        if (diff % i == 0)
        {
          int64 new_x = diff / i;

          if (new_x < x)
          {
            printf("%lli\n", x - new_x);
            Stack.clear();
            break;
          }

          Stack.push_back(new_x);
        }
      }

      while (!Stack.empty())
      {
        int64 i = Stack.back();
        Stack.pop_back();

        int64 new_x = diff / i;

        if (new_x < x)
        {
          printf("%lli\n", x - new_x);
          break;
        }
      }
    }
  }
}

void TaskF( void )
{
  int64 n, k, l, r;
  scanf("%lli %lli\n", &n, &k);

  std::vector<int> Str;
  Str.reserve(n);
  std::vector<int64> Aux;
  Aux.reserve(n);
  std::vector<int64> Peaks {};
  Peaks.reserve(n);

  while (n--)
    Str.push_back(getchar() == '(' ? 1 : -1);

  while (k--)
  {
    Aux.clear();
    Peaks.clear();

    scanf("%lli %lli", &l, &r);

    --l;

    int64 len = r - l;
    int64 Sum = Str[l];
    Aux.push_back(0);

    bool Rising = false;

    for (int64 i = l + 1; i < r; i++)
    {
      Aux.emplace_back(Sum);

      if (Rising)
      {
        if (Str[i] < 0)
          Rising = false;
      }
      else
      {
        if (Str[i] > 0)
        {
          Rising = true;

          if (Sum < 0 && (Peaks.empty() || Aux[Peaks.back()] > Aux.back()))
            Peaks.push_back(Aux.size() - 1);
        }
      }

      Sum += Str[i];
    }

    int64 Res = 0, Stack = 0;

    for (int64 i = l; i < r; i++)
    {
      if (Str[i] > 0)
        ++Stack;
      else
      {
        if (Stack > 0)
          --Stack;
        else
          ++Res;
      }
    }

    Res += Stack;

    for (int64 Shift : Peaks)
    {
      int64 NewRes = Shift;
      Stack = 0;

      for (int64 i = l + Shift; i < r; i++)
      {
        if (Str[i] > 0)
          ++Stack;
        else
        {
          if (Stack > 0)
            --Stack;
          else
            ++NewRes;
        }
      }

      for (int64 i = l; i < l + Shift; i++)
      {
        if (Str[i] > 0)
          ++Stack;
        else
        {
          if (Stack > 0)
            --Stack;
          else
            ++NewRes;
        }
      }

      NewRes += Stack;

      if (NewRes < Res)
        Res = NewRes;
    }

    printf("%lli\n", Res);
  }
}


int main( void )
{
  cin.tie(0)->sync_with_stdio(false);
  cout.tie(0)->sync_with_stdio(false);

  TaskF();

  return 0;
}