#pragma GCC optimize("Ofast,fast-math,unroll-loops")
#include <bits/stdc++.h>
#pragma GCC target("tune=native")
using namespace std;
using ll = long long;
#define CASES

constexpr int MOD = 998244353;

int faf_binpow(int a, ll k) {
    if (k == 0) return 1;
    if (k & 1) return a * 1ll * faf_binpow(a, k - 1) % MOD;
    int t = faf_binpow(a, k / 2);
    return t * 1ll * t % MOD;
}

//inline int faf_binpow(int a, ll k) {
//    int r = 1;
//    for (int b = 42; b >= 0; --b) {
//        r = (r * 1ll * r) % MOD;
//        if ((k >> b) & 1) {
//            r = (r * 1ll * a) % MOD;
//        }
//    }
//    return r;
//}

int dp[5001][10002];
int sr[5001];

int solve(int left, int n, int m) {
    int dmn = faf_binpow(m, (n - 1) * 1ll * (MOD - 2));
    sr[1] = 1;
    const int pivot = n;
    dp[1][pivot] = 1;
    for (int iter = 2; iter <= n; ++iter) {
        for (int l1 = 1; l1 < iter; ++l1) {
            dp[l1][pivot - iter + 1] = sr[l1] * 1ll * (m - 1) % MOD;
            sr[l1] = (sr[l1] + dp[l1][pivot - iter + 1]);
            if (sr[l1] >= MOD) sr[l1] -= MOD;
        }
        int target = pivot + 1;
        for (int l1 = iter; l1 > 1; --l1) {
            --target;
            sr[l1] = (sr[l1] - dp[l1][target]);
            if (sr[l1] < 0) sr[l1] += MOD;
            dp[l1][target] = (dp[l1 - 1][target] + dp[l1][target]);
            if (dp[l1][pivot + l1 - iter] >= MOD) dp[l1][target] -= MOD;
            sr[l1 - 1] = sr[l1 - 1] - dp[l1 - 1][pivot + l1 - iter];
            if (sr[l1 - 1] < 0) sr[l1 - 1] += MOD;
            dp[l1 - 1][pivot + l1 - iter] = 0;
            sr[l1] = (sr[l1] + dp[l1][pivot + l1 - iter]);
            if (sr[l1] >= MOD) sr[l1] -= MOD;
        }
    }
    int v = 0;
    for (int i = 1; i <= n; ++i) {
        v = (v + sr[i] * 1ll * i) % MOD;
    }
//    cerr << v << '\n';
    if (left) {
        for (int i = 0; i <= n; ++i) {
            memset(dp[i], 0, (2 * n + 1) * sizeof(dp[0][0]));
        }
        memset(sr, 0, sizeof(sr[0]) * (n + 1));
    }
    return v * 1ll * dmn % MOD;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int tcases;
    cin >> tcases;
    vector<pair<int, int>> tc(tcases);
    for (int i = 0; i < tcases; ++i) {
        cin >> tc[i].first >> tc[i].second;
    }
    vector<int> rng(tcases);
    std::iota(rng.begin(), rng.end(), 0);
    std::sort(rng.begin(), rng.end(), [&](int l, int r) {
        return tc[l] < tc[r];
    });
    vector<int> ans(tcases);
    int last = rng.back();
    rng.pop_back();
    for (int i : rng) {
        ans[i] = solve(1, tc[i].first, tc[i].second);
    }
    ans[last] = solve(0, tc[last].first, tc[last].second);
    for (int i = 0; i < tcases; ++i) {
        cout << ans[i] << '\n';
    }
    return 0;
}
