#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb emplace_back
#define x first
#define y second
#define ff first
#define ss second

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef complex<double> ftype;
//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
//typedef gp_hash_table<int, int> table;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair <T1, T2>& a){
    is >> a.ff >> a.ss;
    return is;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &list){
    for (auto &x: list)
        in >> x;
    return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream& os, pair <T1, T2> a){
    os << a.ff << " " << a.ss << " ";
    return os;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &list) {
    for (auto x : list)
        out << x << " ";
    return out;
}

mt19937 rnd(31);

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("inline")
*/

//-------------------------------------------

const int MAXN = 4050;

pair<ptll, ptll> seg[MAXN];

ptll vec(ptll a, ptll b){
    return {b.x - a.x, b.y - a.y};
}

ll operator * (ptll a, ptll b){
    return a.x * b.x + a.y * b.y;
}

ll operator% (ptll a, ptll b){
    return a.x * b.y - a.y * b.x;
}

int sigma(ll x){
    if (x < 0)
        return -1;
    if (x > 0)
        return 1;
    return 0;
}

int r[MAXN], p[MAXN];

int get(int x){
    if (x == p[x])
        return x;
    return p[x] = get(p[x]);
}

void Union(int x, int y){
    x = get(x), y = get(y);
    if (r[x] > r[y])
        swap(x, y);
    p[x] = y;
    r[y] += r[x] == r[y];
}

int calc(int i, int j){
    ptll p1 = seg[i].x, p2 = seg[i].y;
    ptll q1 = seg[j].x, q2 = seg[j].y;
    if (p1 == q1 || p1 == q2 || p2 == q1 || p2 == q2)
        return -1;
    ptll p = vec(p1, p2), q = vec(q1, q2);
    if (p % q == 0)
        return 0;
    if (sigma(vec(p1, q1) % p) * sigma(vec(p1, q2) % p) <= 0 && sigma(vec(q1, p1) % q) * sigma(vec(q1, p2) % q) <= 0)
        return -1;
    return 0;
}

void solve(){
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> seg[i].x >> seg[i].y;
    int delta = n;
    fill(r, r + n, 0);
    iota(p, p + n, 0);
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            int val = calc(i, j);
            delta += val;
            if (val < 0)
                Union(i, j);
        }
    }
    set<int> st;
    for (int i = 0; i < n; i++){
        st.insert(get(i));
    }
    cout << 1 + sz(st) - delta << '\n';
}

void run() {
    int t;
    cin >> t;
    while (t--)
        solve();
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif
    auto start = chrono::high_resolution_clock::now();
    run();
    auto stop = chrono::high_resolution_clock::now();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (ld)chrono::duration_cast<chrono::milliseconds>(stop - start).count() / 1e3 << " sec\n";
#endif
    return 0;
}
