#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <stdio.h>
#include <random>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <stack>
#include <queue>
#include <bitset>
#include <complex>
#include <numeric>
#include <climits>

using namespace std;

//#pragma GCC optimize("Ofast")

#define int long long
#define endl '\n'

mt19937_64 engine;
const long long mod = 1e9 + 7;
const long long eps = 1e-10;
const long double pi = acosl(-1.0);

long long sqr(long long x)
{
    return x * x;
}

long long mysqrt(long long x)
{
    long long l = 0;
    long long r = 1e9 + 1;
    while (r - l > 1)
    {
        long long m = (r + l) / 2;
        if (m * m <= x) l = m;
        else r = m;
    }
    return l;
}

long long gcd(long long x, long long y)
{
    if (y == 0) return x;
    return gcd(y, x % y);
}

long long lcm(long long x, long long y)
{
    return x / gcd(x, y) * y;
}

long long binpow(long long x, long long y)
{
    if (y == 0) return 1;
    if (y == 1) return x;
    int f = binpow(x, y / 2);
    if (y % 2 == 0) return (f * f) % mod;
    else return (((f * f) % mod) * x) % mod;
}

void task()
{
    vector<int> pals;
    for (int i = 1; i <= 999; i++)
    {
        string str = to_string(i);
        string rstr = str;
        reverse(rstr.begin(), rstr.end());
        if (str == rstr) pals.push_back(i);
    }

    vector<int> dp(1000, LLONG_MAX);
    dp[0] = 0;

    for (int i = 1; i < 1000; i++)
    {
        for (int j = 0; j < pals.size(); j++)
        {
            int p = pals[j];
            if (p > i) break;

            dp[i] = min(dp[i], dp[i - p] + (int)1);
        }
    }

    int n;
    cin >> n;

    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        cout << dp[x] << endl;
    }
}

signed main()
{
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cout << fixed << setprecision(15);
    engine.seed(58);

    bool multitest = 0;
    int t = 1;
    if (multitest) cin >> t;
    while (t--) task();

    return 0;
}
