﻿// #define _GLICXX_DEBUG
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>

using namespace std;
// using namespace __gnu_pbds;

typedef long long ll;

// #define int ll

ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int bin_pow(int a, int n, int mod) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        int b = bin_pow(a, n / 2, mod);
        return (ll)b * b % mod;
    } else {
        return (ll)a * bin_pow(a, n - 1, mod) % mod;
    }
}

const int MOD = 998244353;


int sign(ll x) {
    if (x > 0) {
        return 1;
    }
    if (x == 0) {
        return 0;
    }
    if (x < 0) {
        return -1;
    }
}

int pr[5000];

int get_pr(int v) {
    if (v == pr[v]) {
        return v;
    }
    return pr[v] = get_pr(pr[v]);
}

void merge(int a, int b) {
    int u = get_pr(a), v = get_pr(b);
    if (u != v) {
        pr[v] = u;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<pair<pair<int, int>, pair<int, int>>> arr(n);
        
        vector<pair<ll, ll>> asdf(n);
        for (int i = 0; i < n; i++) {
            pr[i] = i;
        }

        ll cnt_v = 0, cnt_e = 0;
        for (int i = 0; i < n; i++) {
            cin >> arr[i].first.first >> arr[i].first.second >> arr[i].second.first >> arr[i].second.second;
            int x1, y1, x2, y2;
            x1 = arr[i].first.first, y1 = arr[i].first.second, x2 = arr[i].second.first, y2 = arr[i].second.second;
            for (int j = 0; j < i; j++) {
                int a = arr[j].first.first, b = arr[j].first.second, c = arr[j].second.first, d = arr[j].second.second;
                if (arr[j].first == arr[i].first || arr[j].second == arr[i].first) {
                    merge(i, j);
                    continue;
                }
                if (arr[j].first == arr[i].second || arr[j].second == arr[i].second) {
                    merge(i, j);
                    continue;
                }

                ll A1 = (ll)y1 - y2, B1 = (ll)x2 - x1, C1 = (ll)x1 * y2 - (ll)x2 * y1;
                ll A2 = (ll)b - d, B2 = (ll)c - a, C2 = (ll)a * d - (ll)b * c;
                if (A1 * B2 - A2 * B1 != 0) {
                    int U1 = sign(A1 * a + B1 * b + C1);
                    int U2 = sign(A1 * c + B1 * d + C1);
                    int U3 = sign(A2 * x1 + B2 * y1 + C2);
                    int U4 = sign(A2 * x2 + B2 * y2 + C2);
                    if (U1 * U2 <= 0 && U3 * U4 <= 0) {
                        if (A2 * x1 + B2 * y1 + C2 == 0 || A2 * x2 + B2 * y2 + C2 == 0) {
                            merge(i, j);
                        } else {
                            merge(i, j);
                        }
                    }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            int x1, y1, x2, y2;
            x1 = arr[i].first.first, y1 = arr[i].first.second, x2 = arr[i].second.first, y2 = arr[i].second.second;
            int OOO = 0, FFF = 0;
            OOO += 2;
            FFF = 1;
            for (int j = 0; j < i; j++) {
                int a = arr[j].first.first, b = arr[j].first.second, c = arr[j].second.first, d = arr[j].second.second;
                if (arr[j].first == arr[i].first || arr[j].second == arr[i].first) {
                    OOO--;
                    continue;
                }
                if (arr[j].first == arr[i].second || arr[j].second == arr[i].second) {
                    OOO--;
                    continue;
                }

                ll A1 = (ll)y1 - y2, B1 = (ll)x2 - x1, C1 = (ll)x1 * y2 - (ll)x2 * y1;
                ll A2 = (ll)b - d, B2 = (ll)c - a, C2 = (ll)a * d - (ll)b * c;
                if (A1 * B2 - A2 * B1 != 0) {
                    int U1 = sign(A1 * a + B1 * b + C1);
                    int U2 = sign(A1 * c + B1 * d + C1);
                    int U3 = sign(A2 * x1 + B2 * y1 + C2);
                    int U4 = sign(A2 * x2 + B2 * y2 + C2);
                    if (U1 * U2 <= 0 && U3 * U4 <= 0) {
                        if (A2 * x1 + B2 * y1 + C2 == 0 || A2 * x2 + B2 * y2 + C2 == 0) {
                            FFF++;
                        } else {
                            OOO++;
                            FFF += 2;
                        }
                    }
                }
            }
            asdf[get_pr(i)].first += OOO;
            asdf[get_pr(i)].second += FFF;
        }
        ll ans = 1;
        for (int i = 0; i < n; i++) {
            if (asdf[i].first != 0) {
                ans += max(0LL, 1 + asdf[i].second - asdf[i].first);
            }
        }
        cout << ans << '\n';
        
        
    }
    return 0;
}
