#include <bits/stdc++.h>

#ifndef LOCAL
    //#pragma GCC optimize("Ofast")
    //#pragma GCC optimize("O3, unroll-loops")
    //#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#endif

typedef long long ll;
typedef long double ld;
typedef __int128 lll;
typedef std::pair<int, int> pii;
typedef std::pair<ll, ll> pll;
typedef std::pair<double, double> pdd;
typedef std::pair<ld, ld> pld;
typedef std::pair<lll, lll> plll;
typedef std::vector<int> vii;
typedef std::vector<ll> vll;
typedef std::vector<double> vdd;
typedef std::vector<ld> vld;
typedef std::vector<std::string> vss;
typedef std::vector<pii> vpii;
typedef std::vector<pll> vpll;
typedef std::vector<pdd> vpdd;
typedef std::vector<pld> vpld;
typedef std::vector<vii> vvii;
typedef std::vector<vll> vvll;
typedef std::vector<vdd> vvdd;
typedef std::vector<vld> vvld;
typedef std::vector<vss> vvss;

#define x first
#define y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

//std::istream& operator >> (std::istream& in, lll& a) {
//    std::string s;
//    in >> s;
//    for (char i : s) {
//        a *= 10;
//        a += i - '0';
//    }
//    return in;
//}

pll operator - (pll a) {
    return {-a.x, -a.y};
}

pll operator + (pll a, pll b) {
    return {a.x + b.x, a.y + b.y};
}

pll operator - (pll a, pll b) {
    return {a.x - b.x, a.y - b.y};
}

ll operator * (pll a, pll b) {
    return a.x * b.x + a.y + b.y;
}

ll operator % (pll a, pll b) {
    return a.x * b.y - a.y * b.x;
}

//plll operator - (plll a) {
//    return {-a.x, -a.y};
//}
//
//plll operator + (plll a, plll b) {
//    return {a.x + b.x, a.y + b.y};
//}
//
//plll operator - (plll a, plll b) {
//    return {a.x - b.x, a.y - b.y};
//}
//
//lll operator * (plll a, plll b) {
//    return a.x * b.x + a.y + b.y;
//}
//
//lll operator % (plll a, plll b) {
//    return a.x * b.y - a.y * b.x;
//}

struct segment {
    pll l;
    pll r;
    segment(ll lx = 0, ll ly = 0, ll rx = 0, ll ry = 0) {
        l = {lx, ly};
        r = {rx, ry};
    }
};

segment operator - (segment a) {
    return {-a.l.x, -a.l.y, -a.r.x, -a.r.y};
}

ll get(ll x, vll& p) {
    if (p[x] == x) {
        return x;
    }
    ll y = get(p[x], p);
    p[x] = y;
    return y;
}

void merge(ll x, ll y, vll& p) {
    x = get(x, p);
    y = get(y, p);
    if (x == y) {
        return;
    }
    p[y] = x;
}

using namespace std;

const ll MOD = 998244353, P = 239, inf = INT64_MAX / 2;
const ld PI = acos(-1);

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
#endif
    cout << fixed << setprecision(30);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}

void solve() {
    int n;
    cin >> n;
    vector<segment> p(n);
    vll pr(n);
    for (int i = 0; i < n; i++) {
        pr[i] = i;
    }
    ll E = 0;
    for (int i = 0; i < n; i++) {
        cin >> p[i].l.x >> p[i].l.y >> p[i].r.x >> p[i].r.y;
        if (p[i].l.x > p[i].r.x) {
            swap(p[i].l, p[i].r);
        }
        if (p[i].l.x == p[i].r.x && p[i].l.y > p[i].r.y) {
            swap(p[i].l, p[i].r);
        }
        E--;
        for (int j = 0; j < i; j++) {
            segment l = -p[i], s = p[j];
            swap(l.l, l.r);
            if ((l.r - l.l) % (s.r - s.l) > 0) {
                swap(l, s);
            }
            pll a = l.l + s.l, b = a + (l.r - l.l), c = b + (s.r - s.l), d = c - (l.r - l.l);
            if ((b - a) % (-a) > 0) {
                continue;
            }
            if ((c - b) % (-b) > 0) {
                continue;
            }
            if ((d - c) % (-c) > 0) {
                continue;
            }
            if ((a - d) % (-d) > 0) {
                continue;
            }
            if ((l.r - l.l) % (s.r - s.l) == 0) {
                if (a.x <= 0 && c.x >= 0 && min(a.y, c.y) <= 0 && max(a.y, c.y) >= 0) {
                    E++;
                    merge(i, j, pr);
                }
            } else {
                E++;
                merge(i, j, pr);
            }
        }
    }
    set<ll> s;
    for (int i = 0; i < n; i++) {
        s.insert(get(i, pr));
    }
    cout << E + s.size() + 1 << '\n';
}