#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;
#define int long long
#define endl '\n'

const int MOD = 998244353;
const int N = 5010;

int n, m;
int dp1[N][N]; //mx, len

int bp(int a, int b)
{
	int ans = 1;

	while (b)
	{
		if (b & 1) ans = (ll)ans * a % MOD;

		a = (ll)a * a % MOD;
		b >>= 1;
	}
	return ans;
}

inline void solve()
{
	cin >> n >> m;

	dp1[0][0] = 1;
	for (int mx = 1; mx <= n; ++mx)
	{
		dp1[mx][0] = 1;
		int sum = 1;
		for (int len = 1; len <= n; ++len)
		{
			if (len > mx) sum = (sum + MOD - dp1[mx][len - mx - 1]) % MOD;
			dp1[mx][len] = (ll)sum * (m - 1) % MOD;
			sum += dp1[mx][len];
			sum %= MOD;
		}
	}

	int sum = 0;

	for (int len = 1; len <= n; ++len)
	{
		for (int i = 1; i + len - 1 <= n; ++i)
		{
			int f = (ll)m * dp1[len - 1][i - 1] % MOD * dp1[len][n - (i + len - 1)] % MOD * len % MOD;
			sum += f;
			sum %= MOD;
		}
	}

	int f = bp(bp(m, MOD - 2), n);
	int ans = sum = (ll)f * sum % MOD;

	cout << ans << endl;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}