//macneil
//codeforces meowcneil

#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f(n) for(int i = 0; i < n; ++i)
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;
typedef long double ld;
typedef vector<int> vei;

struct vec {
    ll x, y;
    vec() {}
    vec(int x, int y) : x(x), y(y) {}
    vec(vec a, vec b) : x(b.x-a.x), y(b.y-a.y) {}

    ll operator*(vec other) {
        return x*other.x + y*other.y;
    }
    ll operator^(vec other) {
        return x*other.y - y * other.x;
    }
};

int sign(ll a) {
    if(a==0) return 0;
    if(a>0) return 1;
    return -1;
}

bool is_in(vec a, vec b, vec c) {
    if((a^b)==0||(b^c)==0) return 1;
    if(sign(a^b) == sign(a^c) && abs(atan2(a^b, a*b)) <= abs(atan2(a^c, a*c))) return 1;
    return 0;
}
bool on(vec a, vec b, vec c) {
    vec tmp1(c, a), tmp2(a, c), tmp3(a, b), tmp4(c, b);
    if((tmp1^tmp4)==0) if((tmp2^tmp3)==0) if((tmp1*tmp4)>=0) if((tmp2*tmp3)>=0) return 1;
    return 0;
}

bool inter2(vec a1, vec a2, vec b1, vec b2) {
    vec a(a1, b1), b(a1, a2), c(a1, b2);
    vec A(b1, a1), B(b1, b2), C(b1, a2);
    if(is_in(a, b, c) && is_in(A, B, C)) return 1;
    return 0;
}

bool inter(vec a1, vec a2, vec b1, vec b2) {
    if(on(a1, b1, a2)||on(a1, b2, a2)||on(b1, a1, b2)||on(b1, a2, b2)) return 1;
    if(inter2(a1, a2, b1, b2) && inter2(a2, a1, b2, b1)) return 1;
    return 0;
}


void solve() {
//    cout<<"OK"<<endl;
    int n;
    cin>>n;
    vector<pair<vec, vec>> a(n);
    f(n) cin>>a[i].first.x>>a[i].first.y>>a[i].second.x>>a[i].second.y;
    vector<vector<int>> gr(n);
    for(int i = 0; i < n; ++i) {
        for(int j = i+1; j < n; ++j) {
            if(inter(a[i].first, a[i].second, a[j].first, a[j].second)) {
                gr[i].push_back(j);
                gr[j].push_back(i);
            }
        }
    }
//    for(int i = 0; i < n; ++i) {
//        cout<<i<<": ";
//        for(auto e : gr[i]) cout<<e<<' ';
//        cout<<'\n';
//    }
//    cout<<"OK"<<endl;
    vector<int> szs(n);
    for(int i = 0; i < n; ++i) szs[i] = gr[i].size();
    f(n) {
        vector<int> t;
        for(auto e : gr[i]) {
            if(szs[e] > szs[i] || (szs[i] == szs[e] && e > i)) t.push_back(e);
        }
        swap(t, gr[i]);
    }
    vector<bitset<4000>> cn(n);
    f(n) for(auto e : gr[i]) cn[i][e] = 1;

    int ans = 0;

    for(int i = 0; i < n; ++i) {
        for(auto j : gr[i]) {
            for(auto t : gr[j]) if(cn[i][t]) ans++;
         }
    }
    cout<<ans+1<<'\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int tc = 1;
     cin >> tc;
    for(int i = 0; i < tc; ++i) {
        solve();
    }
}