//macneil
//codeforces meowcneil

#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f(n) for(int i = 0; i < n; ++i)
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;
typedef long double ld;
typedef vector<int> vei;

struct SparseTable {
    vector<vector<int>> sp;
    vector<int> a;

    SparseTable(vector<int> a) : a(a) {
        int n = a.size();
        sp.resize(log2(n)+1, vei(n));
        f(n) sp[0][i] = i;
        for(int i = 1; i < sp.size(); ++i) {
            for(int j = 0; j < n; ++j) {
                int i2 = min(n-1, j+(1<<(i-1)));
                if(a[sp[i-1][j]] < a[sp[i-1][i2]]) sp[i][j] = sp[i-1][j];
                else sp[i][j] = sp[i-1][i2];
            }
        }
    }

    int get_min(int l, int r) { //[r, l)
        int lg = log2(r - l);
        int t = r - (1<<lg);
        if(a[sp[lg][l]] < a[sp[lg][t]]) return sp[lg][l];
        return sp[lg][t];
    }
};

struct pref_sum {
    vector<int> pr;
    pref_sum(vector<int> a) {
        int n = a.size();
        pr.resize(n+1);
        f(n) pr[i+1] = pr[i] + a[i];
    }

    int gt(int l, int r) {
        return pr[r+1] - pr[l];
    }
};


void solve() {
    int n, k;
    cin>>n>>k;
    string s;
    cin>>s;
    vector<int> a(n);
    f(n) {
        if(s[i] == '(') a[i] = 1;
        else a[i] = -1;
    }
    pref_sum prs(a);
    vei pr(n+1);
    f(n) pr[i+1] = pr[i] + a[i];
    SparseTable au(pr);
    f(k) {
//        cout<<i<<endl;
        int l, r;
        cin>>l>>r;
        --l;--r;
        int b = prs.gt(l, r);
        int mn = pr[au.get_min(l+1, r+2)] - pr[l];
        if(mn >= min(0, b)) {
            if(b < 0) {
                cout<<-b<<'\n';
                continue;
            }
            cout<<b<<'\n';
            continue;
        }
        cout<<au.get_min(l+1, r+2)-l+abs(b)<<'\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int tc = 1;
    // cin >> tc;
    for(int i = 0; i < tc; ++i) {
        solve();
    }
}