#include <iostream>
#include <random>
#include <chrono>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cstdio>

using namespace std;

#define int ll
#define ll long long
#define pii pair<int, int>
#define ld long double

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int INF = 1e9 + 50;

vector <int> res;
vector <int> all_dels;

int ans;

void all_dels_find() {
    all_dels = {1};
    int p = 0;
    while (p < res.size()) {
        int sz = all_dels.size();
        int cur = res[p], col = 1;
        p++;
        while (p < res.size() && res[p] == cur) {
            col++;
            p++;
        }
        for (int i = 0 ; i < sz; i++) {
            for (int j = 0 ; j < col; j++) {
                if (j == 0) {
                    all_dels.push_back(all_dels[i] * cur);
                } else {
                    all_dels.push_back(all_dels.back() * cur);
                }
            }
        }
    }
}

void del(int num) {
    res = {};
    int d = 2;
    while (d * d <= (num + 1)) {
        while (num % d == 0) {
            res.push_back(d);   
            num /= d;
        }
        d++;
    }
    if (num != 1) {
        res.push_back(num);
    }
}

void solve() {
    int x, y;
    cin >> x >> y;
    if (x == y) {
        cout << 0 << "\n";
        return;
    }
    int num = y - x;
    del(num);
    all_dels_find();
    ans = x - 1;
    // cerr << "\n";
    for (int i: all_dels) {
        if (i != 1) {
            ans = min(ans, (x - i >= 0 ? x - i : INF));
            // cerr << i << " " << ans << "\n";
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    
}