#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef home
#define dbg(x) cerr << #x << " = " << x << endl;
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")

template <typename T>
istream & operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream & operator << (ostream &os, vector<T> &v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1)
            os << " ";
    }
    return os;
}


mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int getRandom (int l, int r) {
    return rng() % (r - l + 1) + l;
}

struct Fenwick {
    vector<int> t;
    int n;

    void init (int k) {
        n = k + 10;
        t.assign(n + 10, 0);
    }

    int sum (int x) {
        int ans = 0;
        for (; x > 0; x -= x & -x) {
            ans += t[x];
        }
        return ans;
    }

    void upd (int k, int x) {
        for (; k <= n; k += k & -k) {
            t[k] += x;
        }
    }

    int sum (int l, int r) {
        return sum(r) - sum(l - 1);
    }
};

int f (int h0, int w0, int h, int w) {
    return ((w0 + w - 1) / w) * ((h0 + h - 1) / h);
}

void solve() {
    int w0, h0, w, h, x, y;
    cin >> w0 >> h0 >> w >> h >> x >> y;
    int go_x = ((w0 - x - 1) / w) + ((x + w - 1) / w) + 1;
    int go_y = ((h0 - y - 1) / h) + ((y + h - 1) / h) + 1;
    cout << go_x * go_y - 1 << endl;
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}