#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef home
#define dbg(x) cerr << #x << " = " << x << endl;
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")

template <typename T>
istream & operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream & operator << (ostream &os, vector<T> &v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1)
            os << " ";
    }
    return os;
}


mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int getRandom (int l, int r) {
    return rng() % (r - l + 1) + l;
}

struct Fenwick {
    vector<int> t;
    int n;

    void init (int k) {
        n = k + 10;
        t.assign(n + 10, 0);
    }

    int sum (int x) {
        int ans = 0;
        for (; x > 0; x -= x & -x) {
            ans += t[x];
        }
        return ans;
    }

    void upd (int k, int x) {
        for (; k <= n; k += k & -k) {
            t[k] += x;
        }
    }

    int sum (int l, int r) {
        return sum(r) - sum(l - 1);
    }
};

const int N = 1010;

int dp[N];

bool ok (int x) {
    string s = to_string(x);
    string r = s;
    reverse(all(r));
    return r == s;
}

void solve() {
    int n;
    cin >> n;
    cout << dp[n] << endl;
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    fill(dp, dp + N, 1e9);
    dp[0] = 0;
    for (int x = 1; x < N; x++) {
        if (!ok(x)) continue;
        for (int s = 0; s + x < N; s++) {
            dp[x + s] = min(dp[x + s], dp[s] + 1);
        }
    }
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}