#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << ' '; cout << ']'; cout << endl;
#define dbg12(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << " } "; cout << ']'; cout << endl;
#define F first
#define S second

using ll = long long;
using ld = long double;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 2e9;
const ll INFll = 1e18;
const int mod = 1e9 + 7;

struct Vector {
    ll x, y;
    Vector() {}
    Vector(ll x, ll y) : x(x), y(y){}
    ll operator*(Vector b) {
        return x * b.x + y * b.y;
    }
    ll operator%(Vector b) {
        return x * b.y - y * b.x;
    }
    bool operator==(Vector b) {
        return x == b.x && y == b.y;
    }
    Vector operator-(Vector b) {
        return {x - b.x, y - b.y};
    }
};

int sign(ll a) {
    if (a > 0) return 1;
    if (a == 0) return 0;
    return -1;
}

bool intersect(Vector A, Vector B, Vector C, Vector D) { // отрезки AB и CD
    auto ch1 = [&](Vector A, Vector B, Vector C, Vector D) { // A и B по разные стороны
        Vector AB = B - A, AC = C - A, AD = D - A;
        return sign(AB % AC) != sign(AB % AD);
    };
    return ch1(A, B, C, D) && ch1(C, D, A, B);
}

void solve() {
    int n;
    cin >> n;
    vector<pair<Vector, Vector>> segs(n);
    for (auto &[p1, p2] : segs) {
        cin >> p1.x >> p1.y >> p2.x >> p2.y;
    }

    ll ans = 1;
    for (int i = 0; i < n; i++) {
        vector<int> inters;
        for (int j = 0; j < i; j++) {
            if (intersect(segs[i].F, segs[i].S, segs[j].F, segs[j].S)) {
                for (auto k : inters) {
                    if (intersect(segs[j].F, segs[j].S, segs[k].F, segs[k].S))
                        ans++;
                }
                inters.emplace_back(j);
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
    fastIo(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
