/*vector<int> tree;

int get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= qr) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return tree[v];
    }
    return max(get(v * 2 + 1, l, (l + r) / 2, ql, qr), get(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

void upd(int v, int l, int r, int i, int x) {
    if (l + 1 == r) {
        tree[v] = x;
        return;
    }
    if ((l + r) / 2 <= i) {
        upd(v * 2 + 2, (l + r) / 2, r, i, x);
    } else {
        upd(v * 2 + 1, l, (l + r) / 2, i, x);
    }
    tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}*/


#include <iostream>
#include <vector>
#include<algorithm>

using namespace std;

#define int long long

int mod = 998244353;

int power(int n, int k){
    if (k == 1){
        return n;
    }
    int res = power(n, k / 2);
    res = (res * res) % mod;
    if (k & 1){
        res = (res * n) % mod;
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> dp(n + 1, vector<int>(n + 1));
    vector<vector<int>> add(n + 1, vector<int> (n + 1));
    add[0][0] = 1;
    add[1][0] = -1;
    for (int i = 0; i < n; ++i) {
        int c = m;
        if (i > 0) {
            --c;
        }
        int sum = 0;
        for (int j = 0; j <= n; ++j) {
            if (i > 0) {
                add[i][j] += add[i - 1][j];
            }
            dp[i][j] += add[i][j];
            if (j > 0) {
                add[i + 1][j] += dp[i][j] * c;
                add[i + 1][j] %= mod;
                if (i + j <= n) {
                    dp[i + j][j] += sum * c;
                    dp[i + j][j] %= mod;
                    if (i + j + 1 <= n) {
                        add[i + j + 1][j] -= dp[i][j] * c;
                        add[i + j + 1][j] %= mod;
                        add[i + j + 1][j] = (add[i + j + 1][j] + mod) % mod;
                    }
                }
            }
            sum += dp[i][j];
            sum %= mod;
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        add[n][i] += add[n - 1][i];
        dp[n][i] += add[n][i];
        ans += dp[n][i] * i;
        ans %= mod;
    }
    int all = power(m, n);
    cout << (ans * power(all, mod - 2)) % mod << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
