#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")

#define int long long
#define forn(i,n) for(int i=0;i<n;++i)
#define double long double
#define pi pair<int,int>
#define f first
#define s second
#define all(x) x.begin(),x.end()
#define pb push_back
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i]

const int inf=3e18;

struct DSU {
	vector<int> p,sz,rb;
	DSU(int n) {
		forn(i,n) sz.pb(1), p.pb(i);
	}
	int get(int u) {
		return (p[u]==u)?u:get(p[u]);
	}
	void uni(int u, int v) {
		u=get(u), v=get(v);
		if (u==v) {
			rb.pb(-1);
			return;
		}
		if (sz[u]<sz[v]) swap(u,v);
		sz[u]+=sz[v];
		p[v]=u;
		rb.pb(v);
	}
	void roll() {
		int v=rb.back(); rb.pop_back();
		if (v==-1) return;
		int u=p[v];
		sz[u]-=sz[v];
		p[v]=v;
	}
};

struct segment{
	int xb, yb, xe, ye;
	segment(int a, int b, int c, int d) {
		xb=a,yb=b,xe=c,ye=d;
		if (xb>xe) {
			swap(xb,xe);
			swap(yb,ye);
		}
	}
	segment(int z) {
		if (z==-1) return;
	}
};
struct line {
	int vert;
	int x;
	double a,b;
	line(double a, double b, int vert, int x) {
		this->a=a, this->b=b, this->vert=vert, this->x=x;
	}
};
typedef pair<double,double> point;
line toline(segment a) {
	int x1=a.xb, x2=a.xe;
	int y1=a.yb, y2=a.ye;
	if (x1==x2) {
		return line(-1,-1,1,x1);
	}
	double A=1.0*(y2-y1)/(x2-x1);
	double B=y1 - A*x1;
	return line(A,B,0,0);
}
void print(line x) {
	cout<<x.vert<<' '<<x.x<<"  "<<x.a<<' '<<x.b<<'\n';
}

point inter(line a, line b) {
	double a1=a.a, b1=a.b, a2=b.a, b2=b.b;
	if (a.vert) {
		if (b.vert) {
			return {inf,inf};
		} else {
			double x=a.x;
			double y=a2*x+b2;
			return {x,y};
		}
	} else if (b.vert) {
		double x=b.x;
		double y=a1*x+b1;
		return {x,y};
	}
	if (a1==a2) {
		if (b1==b2) return {-inf,inf};
		else return {-inf,-inf};
	}
	double x=1.0*(b2-b1)/(a1-a2);
	double y=a1*x+b1;
	return {x,y};
}

int intersects(segment f, segment s) {
	point z=inter(toline(f),toline(s));
	int x1=f.xb, x2=f.xe, x3=s.xb, x4=s.xe;
	int y1=f.yb, y2=f.ye, y3=s.yb, y4=s.ye;
	if (z.f==inf) {
		if (x1==x3) {
			return (max(y1,y2)==min(y3,y4))||(max(y3,y4)==min(y1,y2));
		} else {
			return 0;
		}
	} else if (z.f==-inf) {
		if (z.s==-inf) return 0;
		return (x2==x3) ||  (x4==x1);
	}
	double x=z.f, y=z.s;
	return (x1<=x && x<=x2) && (x3<=x && x<=x4) && (min(y1,y2)<=y && y<=max(y1,y2)) && (min(y3,y4)<=y && y<=max(y3,y4));
}

void solve() {

	int n; cin>>n;
	DSU dsu(n);
	int ans=0;
	vector<segment> a(n,segment(-1));
	forn(i,n) {
		int x,y,z,b; cin>>x>>y>>z>>b;
		a[i]=segment(x,y,z,b);
		vector<int> cnt(i,0);
		forn(j,i) {
			if (intersects(a[j],a[i])) {
				cnt[dsu.get(j)]++;
			}
		}
		forn(j,i) {
			if (intersects(a[j],a[i])) {
				dsu.uni(i,j);
			}
		}
		forn(j,i) ans+=max(cnt[j]-1,0ll);
	}
	cout<<ans+1<<'\n';

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	cin>>t;
	while(t--) solve();
	return 0;	
}