#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;;

#define all(x) x.begin(), x.end()
#ifdef DUDE
#define debug(x) cout << #x << ":\t" << x << endl
#else
#define debug(x) ;
#endif // DUDE

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec) {
        in >> e;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int) || typeid(T) == typeid(ll))
        end_char = ' ';
    for (const T& e :vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

ll del(ll a, ll b) {
    return (a + b - 1) / b;
}

ll calc(ll w0, ll h0, ll w, ll h) {
    if (w0 <= 0 || h0 <= 0)
        return 0;
    return del(w0, w) * del(h0, h);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    #ifdef DUDE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int test;
    cin >> test;
    while (test--) {
        ll w0, h0, w, h, x, y;
        cin >> w0 >> h0 >> w >> h >> x >> y;
        ll w2 = w0 - x - w;
        ll h2 = h0 - y - h;
        ll res = del(x, w) + del(y, h) + del(w2, w) + del(h2, h) +
               + calc(x, y, w, h) + calc(w2, y, w, h) + calc(w2, h2, w, h) + calc(x, h2, w, h);
        cout << res << '\n';
    }

}
