#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;;

#define all(x) x.begin(), x.end()
#ifdef DUDE
#define debug(x) cout << #x << ":\t" << x << endl
#else
#define debug(x) ;
#endif // DUDE

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec) {
        in >> e;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int))
        end_char = ' ';
    for (const T& e :vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */



int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    #ifdef DUDE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    vector<int> dp(1000, 1000);
    for (int i = 1; i < dp.size(); ++i) {
        vector<int> p;
        int i2 = i;
        while (i2 > 0) {
            p.push_back(i2 % 10);
            i2 /= 10;
        }
        bool pal = true;
        for (int j = 0; j < p.size() / 2; ++j) {
            if (p[j] != p[p.size() - j - 1])
                pal = false;
        }
        if (pal) {
            dp[i] = 1;
            continue;
        }
        for (int j = 1; j < i; ++j) {
            mini(dp[i], dp[j] + dp[i - j]);
        }
    }
    int test;
    cin >> test;
    while (test--) {
        int n;
        cin >> n;
        cout << dp[n] << '\n';
    }
}
