#include <bits/stdc++.h>

#define int long long
#define endl '\n'
#define baza ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

struct segtree {
    vector <int> segtree;
    vector <int> d;

    void apply(int v, int val) {
        segtree[v] += val;
        d[v] += val;
    }

    void pull(int v) {
        segtree[v] = max(segtree[2 * v], segtree[2 * v + 1]);
    }

    void push(int v) {
        apply(2 * v, d[v]);
        apply(2 * v + 1, d[v]);
        d[v] = 0;
    }

    void build (int v, int l, int r, vector <int> & a) {
        if (r == l + 1) {
            segtree[v] = a[l];
            return;
        }
        int m = (l + r + 1) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        segtree[v] = max(segtree[2 * v], segtree[2 * v + 1]);
    }

    void upd (int v, int l, int r, int ql, int qr, int val) {
        if (l >= qr || r <= ql)
            return;
        if (l >= ql && r <= qr) {
            apply(v, val);
            return;
        }
        push(v);
        int m = (l + r + 1) /2;
        upd(2 * v, l, m, ql, qr, val);
        upd(2 * v + 1, m, r, ql, qr, val);
        segtree[v] = max(segtree[2 * v], segtree[2 * v + 1]);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return -10000;
        }
        if (l >= ql && r <= qr) {
            return segtree[v];
        }
        int m = (l + r + 1) / 2;
        push(v);
        int g1 = get(2 * v, l, m, ql, qr), g2 = get(2 * v + 1, m, r, ql, qr);
        return max(g1, g2);
    }
};

int binpow (int a, int b) {
    if (b == 0)
        return 1;
    if (b % 2 == 1) {
        return binpow(a, b - 1) * a;
    }
    int x = binpow(a, b / 2);
    return x * x;
}

vector <int> pal;
vector <int> ans(1000, 3);

void solve() {
    int a, b;
    cin >> a >> b;
    int k = b - a;
    if (b - a == 0) {
        cout << 0 << endl;
        return;
    }
    vector <int> del;
    for (int i = 1; i * i <= k; ++i) {
        if (k % i == 0) {
            del.push_back(i);
            if (i * i != k)
                del.push_back(k / i);
        }
    }
    sort(del.begin(), del.end());
    int l = 0, r  = del.size();
    while(r - l > 1) {
        int m = (r + l) / 2;
        if (del[m] > a) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << a - del[l] << endl;
}

signed main() {
    baza;
    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
}
