#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <random>

#define nx << ' ' <<
#define nl << '\n' <<
#define nlend << '\n'
#define nxend << ' '
#define cft int t; cin >> t; while(t--)

#define int int_fast64_t

using namespace std;

mt19937_64 rnd({random_device{}()});

int getRand(int _min, int _max) {
	uniform_int_distribution<int> pick(_min, _max);
	return pick(rnd);
}

template <class T>
istream& operator>> (istream& str, vector<T>& a) {
	for ( auto& i : a )
		str >> i;
	return str;
}

template <class T>
ostream& operator<< (ostream& str, vector<T>& a) {
	for ( auto i : a )
		str << i << ' ';
	return str;
}

template <class T, class K>
istream& operator>> (istream& str, pair<T, K>& a) {
	str >> a.first >> a.second;
	return str;
}

template <class T, class K>
ostream& operator<< (ostream& str, pair<T, K>& a) {
	str << a.first nx a.second;
	return str;
}

void solve() {
	int x, y;
	cin >> x >> y;
	if ( y % x == 0 ) {
		cout << 0 nlend;
		return;
	}
	set<int> ld;
	int l = sqrt(y - x);
	int r = y - x;
	for ( int i = 1; i <= l; ++i ) {
		if ( r % i == 0 ) {
			ld.insert(i);
			ld.insert(r / i);
		}
	}
	vector<int> fld(ld.begin(), ld.end());
	reverse(fld.begin(), fld.end());
	for ( auto v : fld ) {
		if ( v <= x ) {
			cout << x - v nlend;
			return;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed << setprecision(10);
	cft
	solve();
	return 0;
}