#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <random>

#define nx << ' ' <<
#define nl << '\n' <<
#define nlend << '\n'
#define nxend << ' '
#define cft int t; cin >> t; while(t--)

#define int int_fast64_t

using namespace std;

mt19937_64 rnd({random_device{}()});

int getRand(int _min, int _max) {
	uniform_int_distribution<int> pick(_min, _max);
	return pick(rnd);
}

template <class T>
istream& operator>> (istream& str, vector<T>& a) {
	for ( auto& i : a )
		str >> i;
	return str;
}

template <class T>
ostream& operator<< (ostream& str, vector<T>& a) {
	for ( auto i : a )
		str << i << ' ';
	return str;
}

template <class T, class K>
istream& operator>> (istream& str, pair<T, K>& a) {
	str >> a.first >> a.second;
	return str;
}

template <class T, class K>
ostream& operator<< (ostream& str, pair<T, K>& a) {
	str << a.first nx a.second;
	return str;
}

const int MOD = 998244353;

struct vec2 {
	int x = 0;
	int y = 0;
	int operator* (vec2& b) {
		return x * b.y - y * b.x;
	}
	vec2() {}
	vec2(pair<int, int> a, pair<int, int> b) {
		x = b.first - a.first;
		y = b.second - a.second;
	}
};

bool cl(pair<pair<int, int>, pair<int, int>>& a, pair<pair<int, int>, pair<int, int>>& b) {
	if ( a.first == b.first || a.first == b.second || a.second == b.first || a.second == b.second )
		return 1;
	return 0;
}

bool cl2(pair<pair<int, int>, pair<int, int>>& a, pair<pair<int, int>, pair<int, int>>& b) {
	vec2 _a(a.first, a.second),
		a1(a.first, b.first),
		a2(a.first, b.second),
		_b(b.first, b.second),
		b1(b.first, a.first),
		b2(b.first, a.second);
	if ( _a * a1 == 0 ) {
		int mnx = min(a.first.first, a.second.first),
			mxx = max(a.first.first, a.second.first),
			mny = min(a.first.second, a.second.second),
			mxy = max(a.first.second, a.second.second);
		if(b.first.first <= mxx &&
		   b.first.second <= mxy &&
		   b.first.first >= mnx &&
		   b.first.second >= mny)
			return 1;
	}
	if ( _a * a2 == 0 ) {
		int mnx = min(a.first.first, a.second.first),
			mxx = max(a.first.first, a.second.first),
			mny = min(a.first.second, a.second.second),
			mxy = max(a.first.second, a.second.second);
		if(b.second.first <= mxx &&
		   b.second.second <= mxy &&
		   b.second.first >= mnx &&
		   b.second.second >= mny)
			return 1;
	}
	if ( _b * b1 == 0 ) {
		int mnx = min(b.first.first, b.second.first),
			mxx = max(b.first.first, b.second.first),
			mny = min(b.first.second, b.second.second),
			mxy = max(b.first.second, b.second.second);
		if ( a.first.first <= mxx &&
			a.first.second <= mxy &&
			a.first.first >= mnx &&
			a.first.second >= mny )
			return 1;
	}
	if ( _b * b2 == 0 ) {
		int mnx = min(b.first.first, b.second.first),
			mxx = max(b.first.first, b.second.first),
			mny = min(b.first.second, b.second.second),
			mxy = max(b.first.second, b.second.second);
		if ( a.second.first <= mxx &&
			a.second.second <= mxy &&
			a.second.first >= mnx &&
			a.second.second >= mny )
			return 1;
	}
	return 0;
}

bool inter(pair<pair<int, int>, pair<int, int>>& a, pair<pair<int, int>, pair<int, int>>& b) {
	vec2 _a(a.first, a.second),
		a1(a.first, b.first),
		a2(a.first, b.second),
		_b(b.first, b.second),
		b1(b.first, a.first),
		b2(b.first, a.second);
	if ((_a * a1) * (_a * a2) < 0 && (_b * b1) * (_b * b2) < 0)
		return 1;
	return 0;
}

void solve() {
	//12() - 11() + 2
	int n;
	cin >> n;
	int lines = n, points = 2 * n;
	vector<pair<pair<int, int>, pair<int, int>>> otr(n);
	cin >> otr;
	for ( int i = 0; i < n; ++i ) {
		for ( int j = i + 1; j < n; ++j ) {
			if ( cl(otr[i], otr[j]) ) {
				--points;
				//cout << "CL" nx i nx j nlend;
			}
			else if ( cl2(otr[i], otr[j]) ) {
				++lines;
				//cout << "CL2" nx i nx j nlend;
			}
			else if ( inter(otr[i], otr[j]) ) {
				lines += 2;
				++points;
				//cout << "INTER" nx i nx j nlend;
			}
		}
	}
	cout << lines - points + 2 nlend;
}

/*int gcd(int a, int b, int& x, int& y) {
	if ( b == 0 ) {
		x = 1;
		y = 0;
		return a;
	}
	int x1, y1;
	int d = gcd(b, a % b, x1, y1);
	x = y1;
	y = (d - a * x) / b;
	return d;
}

int rever(int i) {
	int x, y;
	gcd(i, MOD, x, y);
	x %= MOD;
	x += MOD;
	x %= MOD;
	return x;
}

void solve() {
	int n, m;
	cin >> n >> m;
	int ans = 0;
	int del = 0;
	int cur = 1;
	for ( int i = 0; i < n; ++i) {
		del += cur;
		del %= MOD;
		cur *= m - 1;
		cur %= MOD;
	}
	del *= m;
	del %= MOD;
	cur = m;
	for ( int i = 0; i < n; ++i ) {
		ans += (n - i) * cur;
		ans %= MOD;
		cur *= m - 1;
		cur %= MOD;
	}
	int res = ans;
	res %= MOD;
	res *= rever(del);
	res %= MOD;
	cout << res nlend;
}*/

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed << setprecision(10);
	cft
	solve();
	return 0;
}