#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define inf 1e15
#define eps 1e-10
#define re return
#define ll long long
#define ull unsigned long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)

ll gcd(ll a, ll b){ if(a == 0)re b; re gcd(b % a, a); }
ll fast_pow(ll n, ll p){ if(p == 0)re 1; if(p % 2 == 0)re fast_pow(n * n, p / 2); re n * fast_pow(n, p - 1);}
ll mod_fast_pow(ll n, ll p, ll m){ if(p == 0)re 1; if(p % 2 == 0)re mod_fast_pow(n * n % m, p / 2, m); re n * mod_fast_pow(n, p - 1, m) % m; }

template <class T> istream& operator>>(istream& s, vector<T>& v){for(auto &i : v)s >> i; re s;}
template <class T, class U> istream& operator>>(istream& s, pair<T, U>& p) { re s >> p.first >> p.second; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& b) { re {a.first - b.first, a.second - b.second}; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& b) { re {a.first + b.first, a.second + b.second}; }

#define cord pair<ll, ll>
#define x first
#define y second

struct segment{
    cord a, b;
};

struct dsu{
    vector<int> v;

    void build(int n){
        v.resize(n);
        fori(n) v[i] = i;
    }

    int get_par(int i){
        if(v[i] != i)v[i] = get_par(v[i]);
        re v[i];
    }

    void merge(int i1, int i2){
        int p1 = get_par(i1), p2 = get_par(i2);

        if(rand() % 2)swap(p1, p2);

        v[p1] = p2;
    }
};

bool c2(cord a, cord b, cord c, cord d){
    ll q = (b.x - a.x) * (c.y - a.y) - (b.y - a.y) * (c.x - a.x);
    ll w = (b.x - a.x) * (d.y - a.y) - (b.y - a.y) * (d.x - a.x);

    if(q <= 0 && w >= 0)re true;
    if(q >= 0 && w <= 0)re true;
    re false;
}

bool check(segment a, segment b){
    bool ok = true;
    if(max(min(a.a.x, a.b.x), min(b.a.x, b.b.x)) > min(max(a.a.x, a.b.x), max(b.a.x, b.b.x)) ||
        max(min(a.a.y, a.b.y), min(b.a.y, b.b.y)) > min(max(a.a.y, a.b.y), max(b.a.y, b.b.y)))ok = false;

    re (c2(a.a, a.b, b.a, b.b) * c2(b.a, b.b, a.a, a.b)) * ok;
}

void solve(){
    int n; cin >> n;
    vector<segment> seg;
    dsu d;
    d.build(n + 1);

    ll ans = 1;
    fori(n){
        segment q;
        ll x0, y0, x1, y1;
        cin >> x0 >> y0 >> x1 >> y1;
        q = {{x0, y0}, {x1, y1}};

        forj(i){
            if(check(q, seg[j])){
                if(d.get_par(i) == d.get_par(j))ans++;
                else d.merge(i, j);
            }
        }

        seg.push_back(q);
    }

    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t; cin >> t;
    while(t--)solve();
}









